
/* Chrysalide - Outil d'analyse de fichiers binaires
 * restricted-int.h - prototypes internes pour le chargement de données binaires à partir d'un contenu restreint
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Chrysalide.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_CONTENTS_RESTRICTED_INT_H
#define _ANALYSIS_CONTENTS_RESTRICTED_INT_H


#include "restricted.h"


#include "../content-int.h"



/* Contenu de données binaires issues d'un contenu restreint (instance) */
struct _GRestrictedContent
{
    GBinContent parent;                     /* A laisser en premier        */

    GBinContent *internal;                  /* Contenu de sous-traitance   */

    mrange_t range;                         /* Restriction de couverture   */

};

/* Contenu de données binaires issues d'un contenu restreint (classe) */
struct _GRestrictedContentClass
{
    GBinContentClass parent;                /* A laisser en premier        */

};


/* Met en place un contenu restreint de données brutes. */
bool g_restricted_content_create(GRestrictedContent *, GBinContent *, const mrange_t *);



#endif  /* _ANALYSIS_CONTENTS_RESTRICTED_INT_H */
