
/* Chrysalide - Outil d'analyse de fichiers binaires
 * extract-int.h - prototypes internes pour l'organisation d'une extraction d'un élément d'une série interne
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_EXPRS_EXTRACT_INT_H
#define _ANALYSIS_SCAN_EXPRS_EXTRACT_INT_H


#include "extract.h"


#include "access-int.h"



/* Extraction d'un élément donné au sein d'une série interne (instance) */
struct _GScanPendingExtraction
{
    GScanNamedAccess parent;                /* A laisser en premier        */

    GScanExpression *index;                 /* Arguments d'appel fournis   */

};

/* Extraction d'un élément donné au sein d'une série interne (classe) */
struct _GScanPendingExtractionClass
{
    GScanNamedAccessClass parent;           /* A laisser en premier        */

};


/* Met en place une expression d'extraction d'élément interne. */
bool g_scan_pending_extraction_create(GScanPendingExtraction *, const sized_string_t *, GScanExpression *);



#endif  /* _ANALYSIS_SCAN_EXPRS_EXTRACT_INT_H */
